-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.


-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Sat Jul 11 17:31:47 2009

LIBRARY ieee;
USE ieee.std_logic_1164.all;

--  Entity Declaration

ENTITY Data_Converter IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		G_CLK : IN STD_LOGIC;
		Reset : IN STD_LOGIC;

		Data_Converter_In_FIFO_Write_Clk : IN STD_LOGIC;
		Data_Converter_In_FIFO_Data : IN STD_LOGIC_VECTOR(15 downto 0);
		Last_Data_Word : IN STD_LOGIC;
		Data_Converter_In_FIFO_Write : IN STD_LOGIC;
		Data_Converter_In_FIFO_Full : OUT STD_LOGIC;

		Data_Converter_Out_FIFO_Read_Clk : IN STD_LOGIC;
		Data_Converter_Out_FIFO_Data : OUT STD_LOGIC_VECTOR(8 downto 0);
		Data_Converter_Out_FIFO_Read : IN STD_LOGIC;
		Data_Converter_Out_FIFO_Empty : OUT STD_LOGIC;
		
		End_Of_Data_Block : IN STD_LOGIC;
		G_Trigger_Counter : IN STD_LOGIC_VECTOR(31 downto 0);

		Data_Converter_Error : OUT STD_LOGIC_VECTOR(1 downto 0);
		Working_Parameters : IN STD_LOGIC_VECTOR(39 downto 0);

		Jumper_settings_In : IN STD_LOGIC_VECTOR(10 downto 0);
		Jumper_Settings_Out : OUT STD_LOGIC_VECTOR(14 downto 0)
    );
	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END Data_Converter;

--  Architecture Body

ARCHITECTURE Data_Converter_architecture OF Data_Converter IS

	component Data_Converter_In_FIFO
		PORT 
		( 
			aclr	: IN STD_LOGIC ;
			wrclk	: IN STD_LOGIC ;
			wrreq	: IN STD_LOGIC ;
			data	: IN STD_LOGIC_VECTOR (16 DOWNTO 0);
			wrfull	: OUT STD_LOGIC;
			rdclk	: IN STD_LOGIC ;
			rdreq	: IN STD_LOGIC ;
			q		: OUT STD_LOGIC_VECTOR (16 DOWNTO 0);
			rdfull	: OUT STD_LOGIC;
			rdempty	: OUT STD_LOGIC
		 );
	end component;
	
	signal Data_Converter_In_FIFO_read: std_logic;
	signal Data_Converter_In_FIFO_data_out: std_logic_vector(16 downto 0);
	signal Data_Converter_In_FIFO_rdfull: std_logic;
	signal Data_Converter_In_FIFO_rdempty: std_logic;

	alias last_data: std_logic is Data_Converter_In_FIFO_data_out(16);
	
	component Data_Converter_Out_FIFO
		PORT 
		( 
			aclr	: IN STD_LOGIC ;
			wrclk	: IN STD_LOGIC ;
			wrreq	: IN STD_LOGIC ;
			data	: IN STD_LOGIC_VECTOR (8 DOWNTO 0);
			wrfull	: OUT STD_LOGIC;
			rdclk	: IN STD_LOGIC ;
			rdreq	: IN STD_LOGIC ;
			q		: OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
			rdempty	: OUT STD_LOGIC
		 );
	end component;

	signal Data_Converter_Out_FIFO_write: std_logic;
	signal Data_Converter_Out_FIFO_data_in: std_logic_vector(8 downto 0);
	signal Data_Converter_Out_FIFO_wrfull: std_logic;


	type state_type is (Idle,Send_Mini_Header2,Read_Data_Word,Store_Data_Word,Check_In_FIFO,

                        Write_Byte,Wait_Until_Data_Write,Check_Out_FIFO);


	signal current_state, next_state: state_type;


    --Mivel nincs hetes TPC szektor, ezrt ezt a szmot hasznljuk a PSD azonostsra.
	constant TPC_ID: std_logic_vector(2 downto 0):= "000";			--TPC_ID:		"111"= 7.TPC

	--Egyb jelek.
	signal miniheader_sent_ready: std_logic;
	signal dataword2_read_ready: std_logic;
	signal databyte3_write_ready: std_logic;
	signal trigger_counter_signal: std_logic_vector(31 downto 0);

	signal Data_Collecting_Mode: std_logic;

	signal Pedestal_Or_Data_Collecting: std_logic;

	signal Zero_Compression_En: std_logic;

	signal Huffman_Coding_En: std_logic;

	

	--Ezeket a jeleket le kell generlni a Sendig_Controler dobozknak.

	--Felttelezzs, hogy a PSD jumper belltsai pozitv rtelmek, ezrt

	--neglni kell azokat a Sending_Controller szmra (mivel eredetileg a

	--MB jumperei negatv rtelmek, s azokat a Sending_Controller neglja).

	--Tovbb generlni kell a 3 bites Number_Of_FE rtket is, amit aztn a

	--Sending_Controller visszakonvertl kt bites rtkk.
	signal Number_Of_FE: std_logic_vector(2 downto 0);
	signal Sector_ID: std_logic_vector(4 downto 0);
	signal MB_ID: std_logic_vector(2 downto 0);
	signal Resolution: std_logic;

BEGIN


    Jumper_Settings_Out <= TPC_ID & Sector_ID & MB_ID & Number_Of_FE & Resolution;

	comp1: Data_Converter_In_FIFO	
	port map
	(
		aclr	=> Reset,
		wrclk	=> Data_Converter_In_FIFO_Write_Clk,
		wrreq	=> Data_Converter_In_FIFO_Write,
--		data	=> Last_Data_Word & Data_Converter_In_FIFO_Data(13 downto 2),
		data	=> Last_Data_Word & Data_Converter_In_FIFO_Data,

		wrfull	=> Data_Converter_In_FIFO_Full,
		rdclk	=> G_Clk,
		rdreq	=> Data_Converter_In_FIFO_read,
		q		=> Data_Converter_In_FIFO_data_out,
		rdfull	=> Data_Converter_In_FIFO_rdfull,
		rdempty	=> Data_Converter_In_FIFO_rdempty
	);


	comp2: Data_Converter_Out_FIFO	
	port map
	(
		aclr	=> Reset,
		wrclk	=> G_Clk,
		wrreq	=> Data_Converter_Out_FIFO_write,
		data	=> Data_Converter_Out_FIFO_data_in,
		wrfull	=> Data_Converter_Out_FIFO_wrfull,
		rdclk	=> Data_Converter_Out_FIFO_Read_Clk,
		rdreq	=> Data_Converter_Out_FIFO_Read,
		q		=> Data_Converter_Out_FIFO_Data,
		rdempty	=> Data_Converter_Out_FIFO_Empty
	);

--process0: Ms rajellel mkd dobozkkbl jv jelek szinkronizlsa
	process(G_CLK,Reset)
	begin
		if Reset= '1' then
			Data_Collecting_Mode <= '0';
			Pedestal_Or_Data_Collecting <= '0';

			Zero_Compression_En <= '0';

			Huffman_Coding_En <= '0';

			Number_Of_FE <= (others => '0');
			Sector_ID <= (others => '0');
			MB_ID <= (others => '0');
			Resolution <= '0';
			trigger_counter_signal <= (others => '0');

		elsif Rising_Edge(G_CLK) then
			Data_Collecting_Mode <= Working_Parameters(33);
			Pedestal_Or_Data_Collecting <= Working_Parameters(4);

			Zero_Compression_En <= Working_Parameters(2);

			Huffman_Coding_En <= Working_Parameters(3);

            --A PSD 11 bitet hasznl a sajt azonostsra. Ezek pozitv rtelmek, ezrt

            --neglni kell ket a Sending_Controller szmra. Aki viszont a header ellltskor

            --szintn neglja a biteket, vagyis visszall az eredeti rtk.

            --Emellett el kell lltani a hrom bites Number_Of_FE rtket, amit a Sending_Controller

            --Szintn visszaalakt kt bitess a header ellltsakor.

			case Jumper_Settings_In(2 downto 1) is
				when "01" =>
					Number_Of_FE <= "011";
				when "10" =>
					Number_Of_FE <= "101";
				when "11" =>
					Number_Of_FE <= "110";
				when "00" =>
					Number_Of_FE <= "000";
			end case;
			Sector_ID <= not Jumper_Settings_In(10 downto 6);
			MB_ID <= not Jumper_Settings_In(5 downto 3);
			Resolution <= not Jumper_Settings_In(0);
			trigger_counter_signal <= G_Trigger_Counter;

		end if;
	end process;	

--process1: llapotgp regiszter rtkads.
	process(G_CLK,Reset)
    begin
		if Reset= '1' then
			current_state <= Idle;
		elsif Rising_Edge(G_CLK) then
	    	current_state <= next_state;
		end if;
    end process;

--Process2: llapotgp lersa.
	process(current_state,Data_Collecting_Mode,Data_Converter_In_FIFO_rdempty,miniheader_sent_ready,
			dataword2_read_ready,last_data,Data_Converter_Out_FIFO_wrfull,databyte3_write_ready)
	begin
		Data_Converter_In_FIFO_read <= '0';
		case current_state is
			when Idle =>
				if Data_Collecting_Mode= '1' and Data_Converter_In_FIFO_rdempty= '0' then	--Ha adatgyjts van, s kerlt
					next_state <= Send_Mini_Header2;				--adat a bemeneti FIFO-ba, elkezdem felkldeni az adatot.
				else												--Egybknt, vrok az adatra.
					next_state <= Idle;
				end if;
			--j blokk felklds eltt mindg t kell kldeni a "mini header" msodik szavt, ami ngy bjt hossz,
			--s a kvetkezket tartalmazza: Jumper Settings[31..18],Sending Status[17..15],Trigger Counter[14..0]
			when Send_Mini_Header2 =>
				if miniheader_sent_ready= '1' then					--Ha kiklddtt a miniheader2 ngy bjtja,
					next_state <= Read_Data_Word;					--elkezdem kiolvasni az adatokat a bemeneti FIFO-bl.
				else												--Egybknt megvrom, mg a miniheader2
					next_state <= Send_Mini_Header2;				--elkszl.
				end if;
			--Kiolvasok kt 12 bites szt, majd tadom a kimeneti FIFO-nak bjtosval.
			--A 2x12 bitbl 3 bjt jn ki.
			when Read_Data_Word =>
				Data_Converter_In_FIFO_read <= '1';
				next_state <= Store_Data_Word;
			--Eltrolom a beolvasott szt.
			when Store_Data_Word =>
				next_state <= Check_In_FIFO;
			--Megnzem van-e jabb adat a bemeneti FIFO-ban, illetve, hogy nem
			--olvastam-e ki az utols adatszt.
			when Check_In_FIFO =>
				if last_data= '1' then								--Ha megkaptam az utols adatszt,
					next_state <= Check_Out_FIFO;					--kirom a kimeneti FIFO-ba.
				else
					if dataword2_read_ready= '1' then				--Ha beolvastam a msodik adatszt
						next_state <= Check_Out_FIFO;				--kirom a kimeneti FIFO-ba.
					else
						if Data_Converter_In_FIFO_rdempty= '0' then	--Ha van adat a bemeneti FIFO-ban,
							next_state <= Read_Data_Word;			--kiolvasom azt.
						else
							next_state <= Check_In_FIFO;			--Ha nincs, vrok a kvetkez adatra.
						end if;
					end if;
				end if;
				
			--Bjtosval kirja a kimeneti FIFO-ba a bemeneti FIFO-bl jv kt adatszt.
			when Write_Byte =>
				next_state <= Wait_Until_Data_Write;
			--Vrni kell egy rajelet, mg a kimeneti FIFO wrfull bitje bebillen.
			when Wait_Until_Data_Write =>
				next_state <= Check_Out_FIFO;
			--Megnzem van-e mg hely a kimeneti FIFO-ban, s ha van, kirom a kvetkez bjtot.
			--Ha nincs hely, vrakozom, mg a FIFO rl. Ha kirtam mind a hrom bjtot, s mg nem
			--kaptam meg az utols adatszt, olvasom tovbb az esemny adatokat.
			when Check_Out_FIFO =>
				if Data_Converter_Out_FIFO_wrfull= '0' then			--Ha nincs tele a kimeneti FIFO,
					if databyte3_write_ready= '1' then				--megnzem kirtam-e mr minden bjtot.
						if last_data= '1' then						--Ha igen, megnzem nem volt-e esemny vge.
							next_state <= Idle;						--Ha igen, visszatrek alapllapotba.
						else
							next_state <= Check_In_FIFO;			--Ha nem, olvasom tovbb az esemny adtokat.
						end if;
					else											--Ha mg nem rtam ki az sszes bjtot,
						next_state <= Write_Byte;					--folytatom a kirst.
					end if;
				else
					next_state <= Check_Out_FIFO;					--Ha teli van a kimeneti FIFO, vrok, hogy rljn.
				end if;
		end case;
	end process;

--process3: rtkads a jeleknek.
	process(G_CLK,Reset)
	variable miniheader_byte_number: std_logic_vector(1 downto 0);
	variable read_counter: std_logic_vector(0 downto 0);
	variable dataword1: std_logic_vector(11 downto 0);
	variable dataword2: std_logic_vector(11 downto 0);
	variable write_counter: std_logic_vector(1 downto 0);
    begin
		if Reset= '1' then
			Data_Converter_Error <= (others => '0');
			Data_Converter_Out_FIFO_write <= '0';
			Data_Converter_Out_FIFO_data_in <= (others => '0');
			miniheader_byte_number := "00";
			miniheader_sent_ready <= '0';
			read_counter := "0";
			dataword1 := "000000000000";
			dataword2 := "000000000000";
			dataword2_read_ready <= '0';
			write_counter := "00";
			databyte3_write_ready <= '0';
		elsif Rising_Edge(G_CLK) then
			--Hibajelzs kiadsa, ha az adat FIFO-k megtelnek.
			if End_Of_Data_Block= '1' then
				Data_Converter_Error <= (others => '0');
			else
				if Data_Converter_Out_FIFO_wrfull= '1' then
					Data_Converter_Error(0) <= '1';				--Figyelmeztets: megtelt a kimeneti adat FIFO.
				end if;
				if Data_Converter_In_FIFO_rdfull= '1' then
					Data_Converter_Error(1) <= '1';				--Hiba: bemeneti adat FIFO tele,lehet,hogy adatveszts volt.
				end if;
			end if;

			if current_state= Idle then
				miniheader_byte_number := "00";
				miniheader_sent_ready <= '0';
				read_counter := "0";

				dataword1 := "000000000000";
				dataword2 := "000000000000";
				dataword2_read_ready <= '0';

				write_counter := "00";

				databyte3_write_ready <= '0';

				Data_Converter_Out_FIFO_data_in(8) <= '0';
			end if;


			--Miniheader2 kikldse.
			if current_state= Send_Mini_Header2 then
				case miniheader_byte_number is
					when "00" =>							--Kirom az els bjtot.
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= trigger_counter_signal(7 downto 0);
						miniheader_byte_number:= "01";
					when "01" =>							--Kirom a msodik bjtot.
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= Pedestal_Or_Data_Collecting & trigger_counter_signal(14 downto 8);
					--	Data_Converter_Out_FIFO_data_in(7 downto 0) <= '1' & trigger_counter_signal(14 downto 8);
						miniheader_byte_number:= "10";
					when "10" =>							--Kirom a harmadik bjtot.
					--	Data_Converter_Out_FIFO_data_in(7 downto 0) <= MB_ID & Number_Of_FE & Resolution & Zero_Compression_En & Huffman_Coding_En;
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= Jumper_Settings_In(5 downto 0) & Zero_Compression_En & Huffman_Coding_En;

						miniheader_byte_number:= "11";
						miniheader_sent_ready <= '1';		--Miniheader2 ksz (az rs jel visszavonsa miatt adom ki itt).
					when "11" =>							--Kirom a negyedik bjtot.
					--	Data_Converter_Out_FIFO_data_in(7 downto 0) <= TPC_ID & Sector_ID;
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= not TPC_ID & Jumper_Settings_In(10 downto 6);

						miniheader_byte_number:= "00";
				end case;
			end if;

			--Eltrolom a beolvasott adatot.
			if current_state= Store_Data_Word then
				databyte3_write_ready <= '0';				--Itt mr kinullzhatom az rs vge jelzst.
				case read_counter is
					when "0" =>
						dataword1 := Data_Converter_In_FIFO_data_out(11 downto 0);
						dataword2 := "000000000000";
						read_counter := "1";
					when "1" =>
						dataword2 := Data_Converter_In_FIFO_data_out(11 downto 0);
						read_counter := "0";
						dataword2_read_ready <= '1';
				end case;
			end if;
			
			--Kirom az eltrolt adtokat.
			if current_state= Write_Byte then
				dataword2_read_ready <= '0';				--Itt mr kinullzhatom az olvass vge jelzst.
				case write_counter is
					when "00" =>							--1. bjt kirsa.
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= dataword1(7 downto 0);
						write_counter := "01";
					when "01" =>							--2. bjt kirsa.
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= dataword2(3 downto 0) & dataword1(11 downto 8);
						write_counter := "10";
					when "10" =>							--3. bjt kirsa.
						Data_Converter_Out_FIFO_data_in(7 downto 0) <= dataword2(11 downto 4);
						write_counter := "00";
						databyte3_write_ready <= '1';
						if last_data= '1' then
							Data_Converter_Out_FIFO_data_in(8) <= '1';
						end if;
					when others =>
						null;
				end case;
			end if;

			--Kimeneti FIFO berjel kiadsa.
			if current_state= Send_Mini_Header2 or current_state= Write_Byte then
				Data_Converter_Out_FIFO_write <= '1';		--Berjel engedlyezse.
			else
				Data_Converter_Out_FIFO_write <= '0';		--Visszaveszem a kirst.
			end if;

		end if;
	end process;
END Data_Converter_architecture;