-- WARNING: Do NOT edit the input and output ports in this file in a text
-- editor if you plan to continue editing the block that represents it in
-- the Block Editor! File corruption is VERY likely to occur.

-- Copyright (C) 1991-2006 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- Generated by Quartus II Version 6.1 (Build Build 201 11/27/2006)
-- Created on Tue Jan 22 19:26:08 2008

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_unsigned.all;

--  Entity Declaration

ENTITY Sending_Controller_box IS
	-- {{ALTERA_IO_BEGIN}} DO NOT REMOVE THIS LINE!
	PORT
	(
		G_CLK : IN STD_LOGIC;
		Reset : IN STD_LOGIC;

		Tx_Clk	: OUT STD_LOGIC;
		Serial_Out 	: OUT STD_LOGIC;

		Out_FIFO_Data : IN STD_LOGIC_VECTOR(8 downto 0);
		Out_FIFO_Read : OUT STD_LOGIC;
		Out_FIFO_Empty : IN STD_LOGIC;

		Pedestal_Out_FIFO_Data : IN STD_LOGIC_VECTOR(8 downto 0);
		Pedestal_Out_FIFO_Read : OUT STD_LOGIC;
		Pedestal_Out_FIFO_Empty : IN STD_LOGIC;

		Firmware_Out_FIFO_Data : IN STD_LOGIC_VECTOR(8 downto 0);
		Firmware_Out_FIFO_Read : OUT STD_LOGIC;
		Firmware_Out_FIFO_Empty : IN STD_LOGIC;

		Power_Monitor_Out_FIFO_Data : IN STD_LOGIC_VECTOR(8 downto 0);
		Power_Monitor_Out_FIFO_Read : OUT STD_LOGIC;
		Power_Monitor_Out_FIFO_Empty : IN STD_LOGIC;

		Event_Processed : IN STD_LOGIC;
		Event_Processed_Ack : OUT STD_LOGIC;
		ADC_Ready : IN STD_LOGIC;

		Tx_Enable : IN STD_LOGIC;
		Stop_Sending_Data: IN STD_LOGIC;
		Activity : OUT STD_LOGIC;

		FE_Command_Read_Req : IN STD_LOGIC;
		FE_Command_Read : OUT STD_LOGIC;

		LVDS_EN : OUT STD_LOGIC;
		
		End_Of_Data_Block : OUT STD_LOGIC;

		Receiver_Error : IN STD_LOGIC_VECTOR(3 downto 0);
		Firmware_Update_Error : IN STD_LOGIC_VECTOR(2 downto 0);
		Pedestal_Error : IN STD_LOGIC;
		Compressing_Error : IN STD_LOGIC_VECTOR(1 downto 0);
		Power_Monitor_Error : IN STD_LOGIC;
		
		G_Trigger_Counter : IN STD_LOGIC_VECTOR(31 downto 0);
		Working_Parameters : IN STD_LOGIC_VECTOR(39 downto 0);
		Jumper_Settings: IN STD_LOGIC_VECTOR(14 downto 0);
		
		Probajel1: out std_logic;
		Probajel2: out std_logic
	);
	-- {{ALTERA_IO_END}} DO NOT REMOVE THIS LINE!
	
END Sending_Controller_box;

--  Architecture Body

ARCHITECTURE Sending_Controller_box_architecture OF Sending_Controller_box IS

--	Data Block Transfer parancsok
--	constant Block_Transfer_Control: std_logic_vector(3 downto 0):= X"E";
	constant Start_Of_Frame_Control: std_logic_vector(7 downto 0):= X"E0";
	constant Start_Status_Control: std_logic_vector(7 downto 0):= X"E1";
	constant End_Of_Frame_Control: std_logic_vector(7 downto 0):= X"E2";
	constant End_Of_Frame_With_Status_Control: std_logic_vector(7 downto 0):= X"E3";

--	Flow Control parancsok
--	constant Flow_Control_Command: std_logic_vector(3 downto 0):= X"D";
	constant Stop_Sending_Data_Command: std_logic_vector(7 downto 0):= X"D0";
	constant Resume_Sending_Data_Command: std_logic_vector(7 downto 0):= X"D1";

	component transmitter_box
		PORT 
		( 
			G_Clk 	: IN STD_LOGIC;
			Reset 	: IN STD_LOGIC;
			Tx_Data : IN STD_LOGIC_VECTOR(7 downto 0);
			Tx_Data_Type 	: IN STD_LOGIC;
			Tx_Data_Ready 	: IN STD_LOGIC;
			Transmitter_Ready_For_Data_Sending	: OUT STD_LOGIC;
			Transmitter_Ready_For_Status_Sending: OUT STD_LOGIC;
			Tx_Clk		: OUT STD_LOGIC;
			Serial_Out 	: OUT STD_LOGIC
		 );
	end component;
	
	--Transmitter dobozka vezrl jelei.
	signal tx_data_ready_signal: std_logic;							--Ezzel jelzem, ha ksz az adat.
	signal tx_data_type_signal: std_logic;							--Ezzel jelzem, hogy adat vagy kontrollsz megy.
	signal tx_data_signal: std_logic_vector(7 downto 0);			--Ide kerl az adat vagy kontrollsz.
	signal transmitter_ready_for_data_sending_signal: std_logic;	--Adatklds esetn egyel hamarabb jelez.
	signal transmitter_ready_for_status_sending_signal: std_logic;	--Jelez, ha ki lett kldve e kontrollsz.

	--Adatblokk kld llapotgp jelei.
	--Ezek adjk t a jeleket a Transmitter bobozka vezrl jeleinek.
	signal data_ready: std_logic;
	signal data_type: std_logic;
	signal data_byte: std_logic_vector(7 downto 0);

	--Sttussz kld llapotgp jelei.
	--Ezek adjk t a jeleket a Transmitter bobozka vezrl jeleinek.
	signal status_ready: std_logic;
	signal status_type: std_logic;
	signal status_byte: std_logic_vector(7 downto 0);

	--Adatblokkok vge jelzsek.
	alias end_of_data_event: std_logic is Out_FIFO_Data(8);
	alias end_of_pedestal_block: std_logic is Pedestal_Out_FIFO_Data(8);
	alias end_of_firmware_block: std_logic is Firmware_Out_FIFO_Data(8);
	alias end_of_power_monitor_block: std_logic is Power_Monitor_Out_FIFO_Data(8);

	type state_type_ds is (Idle,Send_Start_Of_Frame,Wait_Start_Of_Frame_Ack,
						   Read_Data,Load_Data,Wait_Data_Ack,Wait_State);
	type state_type_cs is (Idle,Send_Start_Status,Wait_Start_Status_Ack,Prepare_Error_Status_Word,
						   Load_Statusbyte1,Wait_Statusbyte1_Ack,Load_Statusbyte2,
						   Wait_Statusbyte2_Ack,Load_Statusbyte3,Wait_Statusbyte3_Ack,
						   Load_Statusbyte4,Wait_Statusbyte4_Ack);
	type state_type_c is (Idle,Wait_Command_Sending_Ack,Send_Status_Word,Send_Data_Block,
						  Send_Stored_Data,Send_Voltage_Information,Send_Error_Status_Word,
						  Prepare_End_Of_Frame,Send_End_Of_Frame,Wait_End_Of_Frame_Ack,
						  FE_Command_Read_Req_Ack);						
							
	signal current_state_ds, next_state_ds: state_type_ds;
	signal current_state_cs, next_state_cs: state_type_cs;
	signal current_state_c, next_state_c: state_type_c;

	signal working_parameters_signal: std_logic_vector(39 downto 0);
	signal tx_enable_signal: std_logic;								--Ezzel jelzi a Receiver dobozka, ha meg kell lltani az adatok felkldst.
	signal stop_sending_data_signal: std_logic;						--Ezzel jelzi a Firmware dobozka, ha meg kell lltani a letltst, mert kezd megtelni a FIFO-ja.
	signal xoff_signal: std_logic;									--Segdjel a Stop iletve Resume_Sending_Data parancsok kiadshoz.

	signal FE_command_read_req_signal: std_logic;					--Parancs rkezett jelzs.
	signal trigger_counter_signal: std_logic_vector(31 downto 0);	--Trigger szmll.
	signal adc_ready_signal: std_logic;								--Ezzel jelzi a Calibration dobozka, ha vgzett a feszltsgrtkek kiolvassval.
	signal voltage_information_ready: std_logic;					--Ezzel jelzem az llapotgpnek, hogy vannak ksz feszltsg adatok.
	signal power_monitor_counter: std_logic_vector(4 downto 0);		--Szmolja hny hny feszltsgadat bjt (16) lett kikldve.
--	signal FIFO_full_signal: std_logic;								--Ha a tmrt dobozka ms rajellel megy, akkor szinkronizlni kell!
	signal data_block_read_ok: std_logic;							--Ez jelzi a vezrl llapotgp fel, hogy ksz egy adatblokk felkldse.
	signal control_information_sent_ok: std_logic;					--Segdjel.Jelzi, hogy esemny vgn ki lett-e kldve a kontrolszt jelz lezrs.

	signal Data_Block_Uploading_Mode: std_logic_vector(2 downto 0);
	signal Data_Collecting_Mode: std_logic;
	signal Pedestal_Or_Data_Collecting: std_logic;
	signal Control_Information_En: std_logic;
	signal Closing_Mode_After_FIFO_Full_Error: std_logic;
	signal Number_Of_FE: std_logic_vector(1 downto 0);
	signal TPC_ID: std_logic_vector(2 downto 0);
	signal Sector_ID: std_logic_vector(4 downto 0);
	signal MB_ID: std_logic_vector(2 downto 0);
	signal Resolution: std_logic;
	signal Send_Status_Word_Command: std_logic_vector(3 downto 0);
	signal Error_Status: std_logic_vector(12 downto 0);
	
	constant Firmware_Version: std_logic_vector(8 downto 0):= "000110111";	--User Firmware: 3v07
	--A legfels bit: 1= Factory, 0= User.
	--A kvetkez 2x4 bit a verzi: fszm.alszm.
BEGIN

Probajel1 <= end_of_pedestal_block;
Probajel2 <= data_block_read_ok;

	comp1: transmitter_box	
	port map
	(
		G_Clk 	=> G_CLK,
		Reset 	=> Reset,
		Tx_Data	=> tx_data_signal,
		Tx_Data_Type => tx_data_type_signal,
		Tx_Data_Ready=> tx_data_ready_signal,
		Transmitter_Ready_For_Data_Sending	=> transmitter_ready_for_data_sending_signal,
		Transmitter_Ready_For_Status_Sending=> transmitter_ready_for_status_sending_signal,
		Tx_Clk		=> Tx_CLK,
		Serial_Out 	=> Serial_Out
	);

--process0: Ms rajellel mkd dobozkkbl jv jelek szinkronizlsa
	process(G_CLK,Reset)
	begin
		if Reset= '1' then
			Data_Block_Uploading_Mode <= (others => '0');
			Data_Collecting_Mode <= '0';
			Pedestal_Or_Data_Collecting <= '0';
			Control_Information_En <= '0';
			Closing_Mode_After_FIFO_Full_Error <= '0';
			Error_Status <= (others => '0');
			Number_Of_FE <= (others => '0');
			TPC_ID <= (others => '0');
			Sector_ID <= (others => '0');
			MB_ID <= (others => '0');
			Resolution <= '0';
			Send_Status_Word_Command <= (others => '0');
			FE_command_read_req_signal <= '0';
			tx_enable_signal <= '0';
			stop_sending_data_signal <= '0';
			working_parameters_signal <= (others => '0');
			trigger_counter_signal <= (others => '0');
			adc_ready_signal <= '0';
--			FIFO_full_signal <= '0';

			--Segdjelek nullzsa.
			Activity <= '0';
			voltage_information_ready <= '0';
			power_monitor_counter <= (others => '0');
			control_information_sent_ok <= '0';

		elsif Rising_Edge(G_CLK) then
			Data_Block_Uploading_Mode <= Working_Parameters(25 downto 23);
			Data_Collecting_Mode <= Working_Parameters(33);
			Pedestal_Or_Data_Collecting <= Working_Parameters(4);
			Control_Information_En <= Working_Parameters(5);
			Closing_Mode_After_FIFO_Full_Error <= Working_Parameters(6);
			Error_Status(10 downto 0) <= Power_Monitor_Error & Compressing_Error & Pedestal_Error & Firmware_Update_Error & Receiver_Error;
			--Jumper settings:
			--Ha zrva van a jumper, akkor az rtk logikai '0'.
			--Ha nyitva van a jumper, akkor az rtk logikai '1'.
			--A megllapods az, hogy a zrt jumper jelentse az '1'-et, a nyitott jumper a '0'-t. Ez
			--a MB-on gy is van feliratozva. Ezrt nekem invertlni kell a Jumper Settings belltst,
			--hogy a helyes rtkeket kldjem tovbb.
			case Jumper_Settings(3 downto 1) is	--Ahol jumper van, ott az rtk 0, egybknt ha res 1.
				when "011" =>
					Number_Of_FE <= "01";		--24x1 konfigurci
				when "101" =>
					Number_Of_FE <= "10";		--12x2 konfigurci
				when "110" =>
					Number_Of_FE <= "11";		--8x3 konfigurci
				when others =>
					Number_Of_FE <= "00";
			end case;
			TPC_ID <= not Jumper_Settings(14 downto 12);
			Sector_ID <= not Jumper_Settings(11 downto 7);
			MB_ID <= not Jumper_Settings(6 downto 4);
			Resolution <= not Jumper_Settings(0);
			Send_Status_Word_Command <= Working_Parameters(32 downto 29);
			FE_command_read_req_signal <= FE_Command_Read_Req;
			tx_enable_signal <= Tx_Enable;
			stop_sending_data_signal <= Stop_Sending_Data;
			working_parameters_signal <= Working_Parameters;
			trigger_counter_signal <= G_Trigger_Counter;
			adc_ready_signal <= ADC_Ready;
--			FIFO_full_signal <= FIFO_Was_Full;

			--Segd s hibajelek belltsa.

			--Activity jel kiadsa.
			if current_state_c= Send_Status_Word or current_state_c= Send_Data_Block or current_state_c= Send_Stored_Data or
			   current_state_c=Send_Voltage_Information or current_state_c= Send_Error_Status_Word then
				Activity <= '1';
			else
				Activity <= '0';
			end if;
			--Hibabitek belltsa.
			if current_state_c= Idle then
				voltage_information_ready <= '0';					--Ha visszatrek alapllapotba, trlhet.
				power_monitor_counter <= (others => '0');			--Ez is, mert mr kikldtem a 16 bjtot.
				control_information_sent_ok <= '0';					--s ezt is, j esemny eltt trlni kell.
				Error_Status(12 downto 11) <= (others => '0');		--Ezek a hibk trlhetk, csak az adott esemnyhez tartoznak.
			else
				--Ha a kontrolsz klds engedlyezve van esemny vgn, akkor annak a kiolvass vgre mr
				--rendelkezsre kell llni. Ha nincsenek ksz esemny vgre a feszltsg adatok, nem ll
				--le a klds, hanem vals adatok helyett kamu adatokat "01"-et kldk. Ilyenkor bebillentem
				--a hibabitet, hogy nem lltak rendelkezsre idben feszltsg adatok.
				if Data_Collecting_Mode= '1' and Control_Information_En= '1' and current_state_c= Send_Voltage_Information then
					if control_information_sent_ok= '0' then
						if adc_ready_signal= '1' then					--Ha adatgyjtskor vge az adatblokknak, s engedlyezve
							voltage_information_ready <= '1';			--van a kontroladat klds, megnzem kiolvashatk-e a feszltsgadatok.
						else											--Ha ilyenkor mg nem jelzi a Calibrcis dobozka,hogy ksz,
							Error_Status(12) <= '1';					--hibt jelzek: nem llt rendelkezsre feszltsg adat.
						end if;
					end if;
				end if;

				--Ha Send_Voltage_Information llapotba vagyok, akkor az azt jelenti, hogy eltte
				--kiadtam azt a fajta esemny lezrst, ami azt jelzi, hogy mg kontroladatok is
				--fognak rkezni. Vagyis a control_information_sent_ok jel mr egybe billenthet.
				--Ez azrt kell, mert norml esemny lezrst csak akkor tudok kiadni, ha ez a jel
				--mr magas, vagy pedig nem kell kontrolinformcit tartalmaznia az esemnynek.
				--A power_monitor adatszmllt minden adatbeolvasskor nvelem, ha feszltsgadat
				--kld llapotban vagyok. 16 bjtot kell kiolvasni a FIFO-bl.
				if current_state_c= Send_Voltage_Information and current_state_ds= Read_Data then
					control_information_sent_ok <= '1';
					power_monitor_counter <= power_monitor_counter + '1';
				end if;
				--Ha a Calibration dobozka kimeneti FIFO-jba valamilyen oknl fogva tbb
				--adat kerl, mint 16 bjt, akkor azt szreveszem, mert a legutols kiolvasott
				--bjt legfels bitje ilyenkor nem egy. Hibt jelzek. El volt csszva az adat.
				if (power_monitor_counter(4) and not end_of_power_monitor_block)= '1' then
					Error_Status(11) <= '1';						--Hiba: blokk olvass hiba. Az utols sz nem lezr.
				end if;
			end if;
		end if;
	end process;
-------------------------------------------
--process1: llapotgp regiszter rtkads
	process(G_CLK,Reset)
    begin
		if Reset= '1' then
			current_state_ds <= Idle;
			current_state_cs <= Idle;
			current_state_c <= Idle;
			xoff_signal <= '0';
		elsif Rising_Edge(G_CLK) then
	    	current_state_ds <= next_state_ds;
			current_state_cs <= next_state_cs;
			current_state_c <= next_state_c;
			if current_state_c= Idle then
			--Visszafkezs engedlyezs/tilts.
				if stop_sending_data_signal= '1' and xoff_signal= '0' then	--Ha kezd teltdni a vevoldali FIFO kiadom a vrakoztats jelet,
					xoff_signal <= '1';										--s jelzem, hogy mr megrrtnt a visszafkezs.
				elsif stop_sending_data_signal= '0' and xoff_signal= '1' then	--Ha ismt van hely a vevoldali FIFO-ban kiadom a klds engedlyezs jelet,
					xoff_signal <= '0';										--s jelzem, hogy mr jraindtottam az adatfolyamot.
				end if;
			end if;
		end if;
    end process;

-------------Control----------------------
--process2: llapotgp lersa
	process(current_state_c,current_state_cs,current_state_ds,FE_command_read_req_signal,Event_Processed,
			Data_Collecting_Mode,Pedestal_Or_Data_Collecting,Data_Block_Uploading_Mode,Out_FIFO_Empty,
			Pedestal_Out_FIFO_Empty,Firmware_Out_FIFO_Empty,Power_Monitor_Out_FIFO_Empty,Send_Status_Word_Command,
			xoff_signal,stop_sending_data_signal,status_ready,status_type,status_byte,data_ready,data_type,
			data_byte,transmitter_ready_for_status_sending_signal,transmitter_ready_for_data_sending_signal,
			data_block_read_ok,Control_Information_En,control_information_sent_ok,
			Closing_Mode_After_FIFO_Full_Error)
			--Huffman_FIFO_Empty	--majd ez is kell!!
	begin
--		Activity <= '0';
		LVDS_EN <= '1';
--Probajel1 <= '0';
		FE_Command_Read <= '0';
		tx_data_ready_signal <= '0';
		tx_data_type_signal <= '0';
		tx_data_signal <= (others => '0');
		Event_Processed_Ack <= '0';						--Visszaigazolom a tmrt dobozknak, hogy vettem az esemnyfeldolgozs vge jelzst.
		End_Of_Data_Block <= '0';						--Ezzel jelzem, hogy befejeztem az adatblokk kldst(kell a busy logikhoz).
		case current_state_c is
			when Idle =>
--Probajel1 <= '1';
				--Adat, adatblokk klds.
				if Data_Collecting_Mode= '1' then											--Ha adatgyjts mdban vagyok.
					if (Pedestal_Or_Data_Collecting= '1' and Out_FIFO_Empty= '0') or			--Norml adatgyjts esetn, vagy
					   (Pedestal_Or_Data_Collecting= '0' and Pedestal_Out_FIFO_Empty= '0') then	--Pedestal adatgyjts esetn.
						next_state_c <= Send_Data_Block;										--Kiolvasom az adatblokkot.
				--Trolt esemny kldse.
					elsif Event_Processed= '1' and Pedestal_Out_FIFO_Empty= '0' then			--Ha nem frt az adat a kimeneti FIFO-ba								--Pedestal memribl jraklds
						next_state_c <= Send_Stored_Data;										--s a Pedestal Memriba lett trolva...
					else
						next_state_c <= Idle;
					end if;
				elsif FE_command_read_req_signal= '1' and Data_Block_Uploading_Mode(0)= '1' then--Blokk felklds esetn.
					next_state_c <= Send_Data_Block;											--Szintn kiolvasom az adatblokkot.
				--Sttussz klds.
				elsif FE_command_read_req_signal= '1' and Send_Status_Word_Command(0)= '1' then
					next_state_c <= Send_Status_Word;
				--Ha kezd teltdni a vevoldali FIFO kiadom a vrakoztats jelet.
				elsif stop_sending_data_signal= '1' and xoff_signal= '0' then
					tx_data_signal <= Stop_Sending_Data_Command;
					tx_data_type_signal <= '1';
					tx_data_ready_signal <= '1';
					next_state_c <= Wait_Command_Sending_Ack;
				--Ha ismt van hely a vevoldali FIFO-ban kiadom a klds engedlyezs jelet.
				elsif stop_sending_data_signal= '0' and xoff_signal= '1' then
					tx_data_signal <= Resume_Sending_Data_Command;
					tx_data_type_signal <= '1';
					tx_data_ready_signal <= '1';
					next_state_c <= Wait_Command_sending_Ack;
				--Ha nem nekem szl a parancs, akkor is vissza kell iagzolni.
				elsif FE_command_Read_req_signal= '1' then
					next_state_c <= FE_Command_Read_Req_Ack;
				else
					next_state_c <= Idle;
				end if;
			----Parancs kldse----
			when Wait_Command_Sending_Ack =>						--Megvrom, mg a kikldtt parancsot visszaigazolja a transceiver.
				if transmitter_ready_for_status_sending_signal = '1' then
					next_state_c <= Idle;
				else
					next_state_c <= Wait_Command_sending_Ack;
				end if;
			----Sttuszsz klds----
			when Send_Status_Word =>
--				Activity <= '1';									--Jelzem, hogy adatmozgs van.
				tx_data_ready_signal <= status_ready;				--tadom a Sttusz kld llapotgp jeleit.
				tx_data_type_signal <= status_type;
				tx_data_signal <= status_byte;
				if current_state_cs= Wait_Statusbyte4_Ack and transmitter_ready_for_status_sending_signal= '1' then
					next_state_c <= FE_Command_Read_Req_Ack;		--Vissza kell igazolnom a vgn a parancsot.
				else
					next_state_c <= Send_Status_Word;
				end if;
			----Adat klds----
			when Send_Data_Block =>
--				Activity <= '1';									--Jelzem, hogy adatmozgs van.
				tx_data_ready_signal <= data_ready;					--tadom az Adat kld llapotgp jeleit.
				tx_data_type_signal <= data_type;
				tx_data_signal <= data_byte;
				--Ha az esemny trolva van, nincs lezz sz, gy nincs data_block_read_ok jelzs sem. Viszont
				--ha az Event Processed jelez, akkor mr nem kerl j adat a kimeneti FIFO-ba. Teht megvrom mg
				--res lesz a kimeneti FIFO, majd visszatrek alapllapotba. Ha ott ltom, hogy adat kerlt a
				--pedestal kieneti FIFO-ba, tlpek trolt esemny kld llapotba, majd folytatom a kiolvasst
				--a Pesdestal kimeneti FIFO-bl.
				if Event_Processed= '1' and Closing_Mode_After_FIFO_Full_Error= '1' then	--Ha az esemny vge kln van trolva,
--					if Out_FIFO_Empty= '1' then						--megnzem resre olvastam-e mr a kimeneti adat FIFO-t. Ha igen
					if current_state_ds= Wait_State and Out_FIFO_Empty= '1' then
						next_state_c <= Idle;						--visszatrek alapllapotba, s vrom, hogy a pedestal FIFO-ba
					else											--adat kerljn. Egybknt olvasom tovbb a kimeneti adat FIFO-t.
						next_state_c <= Send_Data_Block;
					end if;
				else
					if data_block_read_ok= '1' then					--Ha vge az adatblokknak,
						next_state_c <= Prepare_End_Of_Frame;		--ki kell kldeni a lezr kontrolszt.
					else
						next_state_c <= Send_Data_Block;
					end if;
				end if;
			----FIFO teltds miatt tmenetileg trolt adatok kldse----
			when Send_Stored_Data =>
--				Activity <= '1';									--Jelzem, hogy adatmozgs van.
				tx_data_ready_signal <= data_ready;					--tadom az Adat kld llapotgp jeleit.
				tx_data_type_signal <= data_type;
				tx_data_signal <= data_byte;
				if data_block_read_ok= '1' then						--Ha kiolvastam az eltrolt esemny vget,
					next_state_c <= Prepare_End_Of_Frame;			--kldm a lezr kontrolszt.
				else
					next_state_c <= Send_Stored_Data;
				end if;
			----Feszltsgadat klds----
			when Send_Voltage_Information =>
--				Activity <= '1';									--Jelzem, hogy adatmozgs van.
				tx_data_ready_signal <= data_ready;					--tadom az Adat kld llapotgp jeleit.
				tx_data_type_signal <= data_type;
				tx_data_signal <= data_byte;
				if data_block_read_ok= '1' then						--Ha kikldtem a feszltsgadatokat,
					next_state_c <= Send_Error_Status_Word;			--kldm a hibasttuszt.
				else
					next_state_c <= Send_Voltage_Information;
				end if;
			----Hibasttusz klds----
			when Send_Error_Status_Word =>
--				Activity <= '1';									--Jelzem, hogy adatmozgs van.
				tx_data_ready_signal <= status_ready;				--tadom a Sttusz kld llapotgp jeleit.
				tx_data_type_signal <= status_type;
				tx_data_signal <= status_byte;
				if current_state_cs= Wait_Statusbyte4_Ack and transmitter_ready_for_status_sending_signal= '1' then
					next_state_c <= Prepare_End_Of_Frame;			--Ha kikldtem a hibasttuszt is, lezrhatom az esemnyt.
				else
					next_state_c <= Send_Error_Status_Word;
				end if;
			----Esemny lezrsa----
			--Ksleltetni kell egy rajellel a kiadst, klnben beler az
			--utols adat vgbe, levgja annak a 9.(stop)bitjt.
			when Prepare_End_Of_Frame =>
				next_state_c <= Send_End_Of_Frame;
			--Ktfle esemny lezrs van. Ha kontroladatokat is kldk, akkor az esemnyadatok
			--vgt lezrom egy "kontroladatok jnnek" lezrssal, majd ha azok is kimentek,
			--lezrom az esemny vgt egy norml lezrssal.
			--Ha csak esemny adatok jnnek, akkor azokat norml lezrssal zrom le.
			when Send_End_Of_Frame =>
				tx_data_ready_signal <= '1';
				tx_data_type_signal <= '1';
				--Ha kell kontroladatokat kldeni, s mg nem kldtem ki azokat,
				--"kontroladatok jnnek" lezrst adok ki.
				if (Control_Information_En and not control_information_sent_ok)= '1' then
					tx_data_signal <= End_Of_Frame_With_Status_Control;
				--Egybknt norml lezrst adok ki.
				else
					tx_data_signal <= End_Of_Frame_Control;
					Event_Processed_Ack <= '1';					--Itt mr visszaigazolhatom a jelzst.
				end if;
				next_state_c <= Wait_End_Of_Frame_Ack;
			-- state: Wait_End_Of_Frame_Ack
			-- the state-machine waits for the acknowledgment from the
			-- transmitter
			when Wait_End_Of_Frame_Ack =>
				--Ha kell kikldeni kontrol adatokat, s mg nem kldtem ki...
				if (Control_Information_En and not control_information_sent_ok)= '1' then
					if transmitter_ready_for_data_sending_signal = '1' then
						next_state_c <= Send_Voltage_Information;
					else
						next_state_c <= Wait_End_Of_Frame_Ack;
					end if;
				--Ha mr kikldtem, vagy nem is kell kldeni, vge az esemnynek.
				else
					End_Of_Data_Block <= '1';				--Jelzem, hogy vge az adat kiolvassnak.
					if transmitter_ready_for_data_sending_signal = '1' then
						next_state_c <= FE_Command_Read_Req_Ack;	--Visszaigazolom a parancsot. Br ezt adatgyjtskor nem kne, de rtani nem rt.
					else
						next_state_c <= Wait_End_Of_Frame_Ack;
					end if;
				end if;
			----Parancs visszaigazols----
			when FE_Command_Read_Req_Ack =>							--A parancsot vissza kell igazolni,
				FE_Command_Read <= '1';								--mivel azok S kapcsolatban vannak.
				if FE_command_read_req_signal= '0' then
					next_state_c <= Idle;
				else
					next_state_c <= FE_Command_Read_Req_Ack;
				end if;
		end case;
	end process;
-------------------------------------------
-------------Send Data---------------------
--process3: llapotgp llapotok lersa
	process(current_state_c,current_state_ds,tx_enable_signal,transmitter_ready_for_data_sending_signal,
			Out_FIFO_Empty,	Out_FIFO_Data,end_of_data_event,Pedestal_Out_FIFO_Empty,Pedestal_Out_FIFO_Data,
			end_of_pedestal_block,Firmware_Out_FIFO_Empty,Firmware_Out_FIFO_Data,end_of_firmware_block,
			Power_Monitor_Out_FIFO_Empty,Power_Monitor_Out_FIFO_Data,end_of_power_monitor_block,
			Data_Collecting_Mode,Pedestal_Or_Data_Collecting,Data_Block_Uploading_Mode,
			voltage_information_ready,power_monitor_counter)
	begin
		Out_FIFO_Read <= '0';						--Adat FIFO olvas jele.
		Pedestal_Out_FIFO_Read <= '0';				--Pedestal FIFO olvas jele.
		Firmware_Out_FIFO_Read <= '0';				--Firmware FIFO olvas jele.
		Power_Monitor_Out_FIFO_Read <= '0';			--A Power Monitor FIFO olvas jele.
		data_ready  <= '0';							--Ezzel jelzem a transceivernek, hogy ksz egy adatbjt.
		data_byte <= (others => '0');				--Ez a ksz adatbjt.
		data_type <= '0';							--Ezzel jelzem az adat tpust(adat).
		data_block_read_ok <= '0';
		case current_state_ds is
			-- state: Idle
			-- the state-machine is enabled and waits for the data to be
			-- available in the FIFO
			when Idle =>
				if current_state_c= Send_Data_Block and tx_enable_signal= '1' then
					--Ha adatgyjts van, akkor gy kerltem ide, hogy az adat vagy a pedestal FIFO-ba adat kerlt.
					if Data_Collecting_Mode= '1' then
						next_state_ds <= Send_Start_Of_Frame;
					--Egybknt blokk felklds miatt vagyok itt, megvrom, mg adat kerl a FIFO-ba.
					elsif (Data_Block_Uploading_Mode= "001" and Pedestal_Out_FIFO_Empty= '0') or
						  (Data_Block_Uploading_Mode= "101" and Firmware_Out_FIFO_Empty= '0') or
						  (Data_Block_Uploading_Mode= "111" and Power_Monitor_Out_FIFO_Empty= '0') then
						next_state_ds <= Send_Start_Of_Frame;
					else
						next_state_ds <= Idle;
					end if;
				--Ez azrt nem kell, mert adatgyjts mdban folyamatosan olvasom a kimeneti adat FIFO-t. A vezrl
				--llapotgp figyeli, hogy megjelent-e az Event Processed jel. Ilyenkor a kimeneti adat FIFO-t mr
				--resre olvashatja. Ha kirlt a kimeneti adat FIFO, visszatrek Idle-ba, s ott vrakozik, mg
				--a pedestal kimeneti FIFO-ba adat nem kerl.
				--Ezalatt az adat kld llapotgp folyamatosan olvassa a kimeneti adat FIFO-t. Amikor res lesz
				--a FIFO, elmegy vrakoz llapotba. s ott is ragad.
				--Amikor megjeleni adat a pedestal kimeneti FIFO-ban, a vezrl llapotgp tlp a trolt esemnyek
				--kldse llapotba.
				--Az adat kld llapotgp ilyenkor ki tud ugrani a vrakoz llapotbl, mert igaz lesz egy felttel,
				--mgpedig, hogy trolt adat klds llapot van, s a pedestal kimeneti FIFO nem res.
				--Ilyenkor rgtn FIFO olvass llapotba ugrik, s onnantl a pedestal kimeneti FIFO-bl fogja szedni
				--az adatokat, egszen az adat vge jelzsig (9.bit). Ekkor visszatr mindenki Idle-ba.
				elsif current_state_c= Send_Voltage_Information and tx_enable_signal= '1' then
					next_state_ds <= Read_Data;
				else
					next_state_ds <= Idle;
				end if;
			-- state: Send_Start_Of_Frame_Word
			-- the state-machine requests the transfer of the Start of Event
			-- control word
			when Send_Start_Of_Frame =>
				data_ready <= '1';
				data_type <= '1';
				data_byte <= Start_Of_Frame_Control;
				next_state_ds <= Wait_Start_Of_Frame_Ack;
			-- state: Wait_Start_Of_Frame_Ack
			-- the state-machine waits for the acknowledgment from the
			-- transmitter
			when Wait_Start_Of_Frame_Ack =>
				if transmitter_ready_for_data_sending_signal = '1' then
					next_state_ds <= Read_Data;
				else
					next_state_ds <= Wait_Start_Of_Frame_Ack;
				end if;
			-- state: Data_Read
			-- the state-machine reads the data from the FIFO
			when Read_Data =>
				if current_state_c= Send_Voltage_Information then
					if voltage_information_ready= '1' then			--Ha esemny vgn a tpfeszltsg adatokat
						Power_Monitor_Out_FIFO_Read <= '1';			--kell felkldenem, s azok ksz is vannak.
					end if;
				elsif Data_Block_Uploading_Mode= "111" then
					Power_Monitor_Out_FIFO_Read <= '1';				--Ha a tpfeszltsg rtkeket olvasom.
				elsif Data_Block_Uploading_Mode= "101" then
					Firmware_Out_FIFO_Read <= '1';					--Ha a Configurcis EPROM-ot olvasom.
				elsif Data_Block_Uploading_Mode= "001" then
					Pedestal_Out_FIFO_Read <= '1';					--Ha a pedestal memrit olvasom.
				elsif current_state_c= Send_Stored_Data then		
					Pedestal_Out_FIFO_Read <= '1';					--Ha a jra kell kldenem az esemny vgt.
				elsif Data_Collecting_Mode= '1' then
					if Pedestal_Or_Data_Collecting= '1' then
						Out_FIFO_Read <= '1';						--Ha norml adatot krek.
					else
						Pedestal_Out_FIFO_Read <= '1';				--Ha a pedestal memrit olvasom.
					end if;
				end if;
				next_state_ds <= Load_Data;
			-- state: Load_Data
			-- the state-machine requests the transfer of the data word
			when Load_Data =>
				data_ready <= '1';
				if current_state_c= Send_Voltage_Information then
					if voltage_information_ready= '1' then					--Ha esemny vgn a tpfeszltsg adatokat
						data_byte <= Power_Monitor_Out_FIFO_Data(7 downto 0);--kell felkldenem, s azok ksz is vannak.
					else													--Ha nem lettek ksz a kldsig, helyettet
						data_byte <= "00000001";							--rtkknt 1-et kldk, ami elvileg nem lehet.
					end if;
				elsif Data_Block_Uploading_Mode= "111" then
					data_byte <= Power_Monitor_Out_FIFO_Data(7 downto 0);	--Ha a tpfeszltsg rtkeket olvasom.
				elsif Data_Block_Uploading_Mode= "101" then
					data_byte <= Firmware_Out_FIFO_Data(7 downto 0);		--Ha a Configurcis EPROM-ot olvasom.
				elsif Data_Block_Uploading_Mode= "001" then
					data_byte <= Pedestal_Out_FIFO_Data(7 downto 0);		--Ha a pedestal memrit olvasom.
				elsif current_state_c= Send_Stored_Data then
					data_byte <= Pedestal_Out_FIFO_Data(7 downto 0);		--Ha a jra kell kldenem az esemny vgt.
				elsif Data_Collecting_Mode= '1' then
					if Pedestal_Or_Data_Collecting= '1' then
						data_byte <= Out_FIFO_Data(7 downto 0);				--Ha norml adatot krek.
					else
						data_byte <= Pedestal_Out_FIFO_Data(7 downto 0);	--Ha a pedestal memrit olvasom.
					end if;
				end if;
				next_state_ds <= Wait_Data_Ack;
			-- state: Wait_Data_Ack
			-- the state-machine waits for the acknowledgment from the
			-- transmitter
			when Wait_Data_Ack =>
				if transmitter_ready_for_data_sending_signal = '1' then
					if current_state_c= Send_Voltage_Information then	--Ha feszltsg adokat kell kldenem,
						if power_monitor_counter(4)= '1' then			--s kikldtem mind a 16 bjtot.
							data_block_read_ok <= '1';					--Ki kell adni a vge jelet.
							next_state_ds <= Idle;
						elsif tx_enable_signal= '0' then				--Itt nem ll fel az az eset, hogy a FIFO
							next_state_ds <= Wait_State;				--kirljn. Meret ha megkaptam
						else											--az ADC_Ready jelzst, a FIFO-ba
							next_state_ds <= Read_Data;					--mr nem kerl adat.
						end if;											
					elsif current_state_c= Send_Stored_Data then		--Ha a FIFO teltds miatt az SRAM-ba trolt
						if end_of_pedestal_block= '1' then				--adatokat olvasom, s vge a blokknak,
							data_block_read_ok <= '1';					--ki kell adni a vge jelet.
							next_state_ds <= Idle;
						elsif tx_enable_signal= '0' or Pedestal_Out_FIFO_Empty= '1' then	--Ha kirl a Pedestal FIFO, s
							next_state_ds <= Wait_State;				--mg nincs adatblokk vge, vrakozok az adatra.
						else
							next_state_ds <= Read_Data;
						end if;
					--Ha adatgyjts, vagy blokklds van, s megjn az adat vge jelzs...
					elsif (Pedestal_Or_Data_Collecting= '1' and end_of_data_event= '1') or
						  (Pedestal_Or_Data_Collecting= '0' and end_of_pedestal_block= '1') or
						  (Data_Block_Uploading_Mode= "001" and end_of_pedestal_block= '1') or
						  (Data_Block_Uploading_Mode= "101" and end_of_firmware_block= '1') or
						  (Data_Block_Uploading_Mode= "111" and end_of_power_monitor_block= '1') or
						  (current_state_c= Send_Stored_Data and end_of_pedestal_block= '1') then
						data_block_read_ok <= '1';					--Ki kell adni a vge jelet.
						next_state_ds <= Idle;
					--Ha adatgyjts vagy blokklds kzben az olvasott FIFO kirl vagy
					--visszafkezs van a koncentrtor fell, vrakozni kell.
					elsif tx_enable_signal= '0' or																				--Ha visszafkezs van, vagy a kimeneti FIFO-k resek.
						  (Data_Collecting_Mode= '1' and Pedestal_Or_Data_Collecting= '1' and Out_FIFO_Empty= '1') or			--Elfogyott az adat az Adat FIFO-bl esemny vge eltt.
						  (Data_Collecting_Mode= '1' and Pedestal_Or_Data_Collecting= '0' and Pedestal_Out_FIFO_Empty= '1') or	--Elfogyott az adat a Pedestal FIFO-bl esemny vge eltt.
						  (Data_Block_Uploading_Mode= "001" and Pedestal_Out_FIFO_Empty= '1') or								--Elfogyott az adat a Pedestal FIFO-bl blokk vge eltt.
						  (Data_Block_Uploading_Mode= "101" and Firmware_Out_FIFO_Empty= '1') or								--Elfogyott az adat a Firmware FIFO-bl blokk vge eltt.
						  (Data_Block_Uploading_Mode= "111" and Power_Monitor_Out_FIFO_Empty= '1') or							--Elfogyott az adat a Feszltsg FIFO-bl blokk vge eltt.
						  (current_state_c= Send_Stored_Data and Pedestal_Out_FIFO_Empty= '1') then								--Elfogyott az adat a Pedestal FIFO-bl esemny jrakldskor.
						next_state_ds <= Wait_State;
					else
						next_state_ds <= Read_Data;
					end if;
				else
					next_state_ds <= Wait_Data_Ack;
				end if;
			-- state: Wait_State
			-- the state-machine waits for the data to be available in the FIFO,
			-- or for the XON signal
			when Wait_State =>
				if tx_enable_signal= '1' and																			--Ha vge a visszafkezsnek, s adat is van a kimenti FIFO-kban.
				   ((Data_Collecting_Mode= '1' and Pedestal_Or_Data_Collecting= '1' and Out_FIFO_Empty= '0') or			--Ismt adat kerlt az adat FIFO-ba adatgyjtskor.
				   (Data_Collecting_Mode= '1' and Pedestal_Or_Data_Collecting= '0' and Pedestal_Out_FIFO_Empty= '0') or	--Ismt adat kerlt a pedestal FIFO-ba pedestalgyjtskor.
				   (Data_Block_Uploading_Mode= "001" and Pedestal_Out_FIFO_Empty= '0') or								--Ismt adat kerlt a pedestal FIFO-ba pedestal blokk kldskor.
				   (Data_Block_Uploading_Mode= "101" and Firmware_Out_FIFO_Empty= '0') or								--Ismt adat kerlt a Firmware FIFO-ba firmware blokk kldskor.
				   (Data_Block_Uploading_Mode= "111" and Power_Monitor_Out_FIFO_Empty= '0') or							--Ismt adat kerlt a Kalibrcis FIFO-ba feszltsg blokk kldskor.
				   (current_state_c= Send_Stored_Data and Pedestal_Out_FIFO_Empty= '0')) then							--Ismt adat kerlt a pedestal FIFO-ba esemny jrakldskor.
					next_state_ds <= Read_Data;
				else
					next_state_ds <= Wait_State;
				end if;
		end case;
	end process;
---------------------------------------------
-------------Send_Control--------------------
--process4: llapotgp lersa
	process(current_state_c,current_state_cs,trigger_counter_signal,working_parameters_signal,
			Error_Status,TPC_ID,Sector_ID,MB_ID,Resolution,Number_Of_FE,Send_Status_Word_Command,
			transmitter_ready_for_status_sending_signal)
		begin
		status_ready  <= '0';					--Ezzel jelzem a transceivernek, hogy ksz egy adatbjt.
		status_byte <= (others => '0');			--Ez a ksz sttuszbjt.
		status_type <= '0';						--Ezzel jelzem az adat tpust(parancs).
		case current_state_cs is
			when Idle =>
				if current_state_c= Send_Status_Word then
					next_state_cs <= Send_Start_Status;
				elsif current_state_c= Send_Error_Status_Word then
					next_state_cs <= Prepare_Error_Status_Word;
				else
					next_state_cs <= Idle;
				end if;
			--Ksleltetni kell egy rajellel a hibasttusz kiadst, klnben
			--beler az utols adat vgbe, levgja annak a 9.(stop)bitjt.
			when Prepare_Error_Status_Word =>
				next_state_cs <= Load_Statusbyte1;

			when Send_Start_Status =>			--Kikldm a sttusz start parancsot.
				status_ready <= '1';
				status_type <= '1';
				status_byte <= Start_Status_Control;
				next_state_cs <= Wait_Start_Status_Ack;
			when Wait_Start_Status_Ack =>		--Megvrom, mg kimegy a parancs.
				if transmitter_ready_for_status_sending_signal = '1' then
					next_state_cs <= Load_Statusbyte1;
				else
					next_state_cs <= Wait_Start_Status_Ack;
				end if;
			when Load_Statusbyte1 =>			--Majd kikldm a ngy sttuszbjtot.
				status_ready <= '1';
				if Send_Status_Word_Command= "0001" then		--Ami lehet mkdsi paramter.
					status_byte <= working_parameters_signal(7 downto 0);
				elsif Send_Status_Word_Command= "0101" then		--Jumper bellts.
					status_byte <= Sector_ID(1 downto 0) & MB_ID & Number_Of_FE & Resolution;
				elsif Send_Status_Word_Command= "0011" then		--Trigger szmll.
					status_byte <= trigger_counter_signal(7 downto 0);
				elsif Send_Status_Word_Command= "0111" or current_state_c= Send_Error_Status_Word then	--Hiba sttusz.
					status_byte <= Error_Status(7 downto 0);
				elsif Send_Status_Word_Command= "1001" then	--Firmware verzi.
					status_byte <= Firmware_Version(7 downto 0);
				end if;
				next_state_cs <= Wait_Statusbyte1_Ack;
			when Wait_Statusbyte1_Ack =>
				if transmitter_ready_for_status_sending_signal = '1' then
					next_state_cs <= Load_Statusbyte2;
				else
					next_state_cs <= Wait_Statusbyte1_Ack;
				end if;
			when Load_Statusbyte2 =>
				status_ready <= '1';
				if Send_Status_Word_Command= "0001" then
					status_byte <= working_parameters_signal(15 downto 8);
				elsif Send_Status_Word_Command= "0101" then
					status_byte <= "00" & TPC_ID & Sector_ID(4 downto 2);
				elsif Send_Status_Word_Command= "0011" then
					status_byte <= trigger_counter_signal(15 downto 8);
				elsif Send_Status_Word_Command= "0111" or current_state_c= Send_Error_Status_Word then		--Hiba sttusz.
					status_byte <= "000" & Error_Status(12 downto 8);
				elsif Send_Status_Word_Command= "1001" then
					status_byte <= "0000000" & Firmware_Version(8);
				end if;
				next_state_cs <= Wait_Statusbyte2_Ack;
			when Wait_Statusbyte2_Ack =>
				if transmitter_ready_for_status_sending_signal = '1' then
					next_state_cs <= Load_Statusbyte3;
				else
					next_state_cs <= Wait_Statusbyte2_Ack;
				end if;
			when Load_Statusbyte3 =>
				status_ready <= '1';
				if Send_Status_Word_Command= "0001" then
					status_byte <= working_parameters_signal(23 downto 16);
				elsif Send_Status_Word_Command= "0101" then
					status_byte <= "00000000";
				elsif Send_Status_Word_Command= "0011" then
					status_byte <= trigger_counter_signal(23 downto 16);
				elsif Send_Status_Word_Command= "0111" or current_state_c= Send_Error_Status_Word then		--Hiba sttusz.
					status_byte <= "00000000";
				elsif Send_Status_Word_Command= "1001" then
					status_byte <= "00000000";
				end if;
				next_state_cs <= Wait_Statusbyte3_Ack;
			when Wait_Statusbyte3_Ack =>
				if transmitter_ready_for_status_sending_signal = '1' then
					next_state_cs <= Load_Statusbyte4;
				else
					next_state_cs <= Wait_Statusbyte3_Ack;
				end if;
			when Load_Statusbyte4 =>
				status_ready <= '1';
				if Send_Status_Word_Command= "0001" then
					status_byte <= working_parameters_signal(31 downto 24);
				elsif Send_Status_Word_Command= "0101" then
					status_byte <= "00000000";
				elsif Send_Status_Word_Command= "0011" then
					status_byte <= trigger_counter_signal(31 downto 24);
				elsif Send_Status_Word_Command= "0111" or current_state_c= Send_Error_Status_Word then		--Hiba sttusz.
					status_byte <= "00000000";
				elsif Send_Status_Word_Command= "1001" then
					status_byte <= "00000000";
				end if;
				next_state_cs <= Wait_Statusbyte4_Ack;
			when Wait_Statusbyte4_Ack =>
				if transmitter_ready_for_status_sending_signal = '1' then
					next_state_cs <= Idle;
				else
					next_state_cs <= Wait_Statusbyte4_Ack;
				end if;
		end case;
	end process;	
END Sending_Controller_box_architecture;
